// vertex shader for light mapping

varying vec3 LightDir;
varying vec3 EyeDir;
uniform vec3 LightPosition;
attribute vec3 Tangent;

//pass through the texture coordinates

void main()
{
   // light map
   gl_TexCoord[0] = gl_MultiTexCoord0;
   gl_TexCoord[1] = gl_MultiTexCoord1; // normal map

   // normal map
   EyeDir         = vec3(gl_ModelViewMatrix * gl_Vertex);
   gl_Position    = ftransform();
   vec3 n = normalize(gl_NormalMatrix * gl_Normal);
   vec3 t = normalize(gl_NormalMatrix * Tangent);
   vec3 b = cross(n, t);
   vec3 v;

   vec4 tmpLight = vec4(LightPosition.x, LightPosition.y, LightPosition.z, 1);
   vec3 LightPos = vec3(gl_ModelViewMatrix * tmpLight);
   v.x = dot(LightPosition, t);
   v.y = dot(LightPosition, b);
   v.z = dot(LightPosition, n);
   LightDir = normalize(v);
   v.x = dot(EyeDir, t);
   v.y = dot(EyeDir, b);
   v.z = dot(EyeDir, n);
   EyeDir = normalize(v);

   gl_FrontColor = gl_Color;
   gl_BackColor = gl_Color;
}
