// vertex shader for light mapping

varying vec3 LightDir;
varying vec3 EyeDir;
uniform vec3 LightPosition;
attribute vec3 Tangent;
varying vec3 VNormal;

//pass through the texture coordinates

void main()
{
   // light map
   gl_TexCoord[0] = gl_MultiTexCoord0;

   // normal map
   EyeDir         = vec3(gl_ModelViewMatrix * gl_Vertex);
   gl_Position    = ftransform();
   vec3 n = normalize(gl_NormalMatrix * gl_Normal);
   vec3 t = normalize(gl_NormalMatrix * Tangent);
   vec3 b = cross(n, t);
   vec3 v;

   VNormal = gl_Normal;

   v.x = dot(LightPosition, t);
   v.y = dot(LightPosition, b);
   v.z = dot(LightPosition, n);
   LightDir = normalize(v);
   v.x = dot(EyeDir, t);
   v.y = dot(EyeDir, b);
   v.z = dot(EyeDir, n);
   EyeDir = normalize(v);

   gl_FrontColor = gl_Color;
   gl_BackColor = gl_Color;

   //if(dot(t, n) > 0.01) {
   //   gl_FrontColor = vec4(1.0, 0.0, 223.0 / 255.0, 1.0);
   //}

}
